Attribute VB_Name = "modAPI"
Option Explicit

' Diese Code stammt Florian Rittmeier <florian@activevb.de>
' fr ActiveVb.de
' Es wird keinerlei Haftung oder hnliches bernommen

' Konstante fr CreateFileMapping
Public Const PAGE_READWRITE As Long = &H4
Public Const INVALID_HANDLE_VALUE As Long = -1

' Konstanten fr MapViewOfFile
Public Const SECTION_MAP_WRITE As Long = &H2
Public Const FILE_MAP_WRITE As Long = SECTION_MAP_WRITE

' Konstante fr FormatMessage
Public Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000

'Die Bounds fr das SafeArray
Public Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

'Das SafeArray, eindimensional
Public Type SAFEARRAY1D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 0) As SAFEARRAYBOUND
End Type

' Datei- und FileMappingHandles schlieen
Public Declare Function CloseHandle Lib "kernel32.dll" ( _
     ByVal hObject As Long) As Long

' FileMapping mglich machen
Public Declare Function CreateFileMapping Lib "kernel32.dll" Alias "CreateFileMappingA" ( _
     ByVal hFile As Long, _
     lpFileMappigAttributes As Long, _
     ByVal flProtect As Long, _
     ByVal dwMaximumSizeHigh As Long, _
     ByVal dwMaximumSizeLow As Long, _
     ByVal lpName As String) As Long

' Daten in Addressraum laden
Public Declare Function MapViewOfFile Lib "kernel32.dll" ( _
     ByVal hFileMappingObject As Long, _
     ByVal dwDesiredAccess As Long, _
     ByVal dwFileOffsetHigh As Long, _
     ByVal dwFileOffsetLow As Long, _
     ByVal dwNumberOfBytesToMap As Long) As Long

' Daten aus Addressraum werfen
Public Declare Function UnmapViewOfFile Lib "kernel32.dll" ( _
     lpBaseAddress As Any) As Long

' Speicher durch die Gegend schupsen
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
     Destination As Any, _
     Source As Any, _
     ByVal Length As Long)
Public Declare Sub CopyMemoryByString Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
     Destination As String, _
     Source As Any, _
     ByVal Length As Long)

' Richtig illegale Sachen mit Arrays machen ;-)
Public Declare Function VarPtrArray Lib "msvbvm60.dll" _
    Alias "VarPtr" (Ptr() As Any) As Long

' ordentliche Fehlermeldungen bekommen
Private Declare Function FormatMessage Lib "kernel32" Alias _
        "FormatMessageA" (ByVal dwFlags As Long, lpSource _
        As Any, ByVal dwMessageId As Long, ByVal dwLanguageId _
        As Long, ByVal lpBuffer As String, ByVal nSize As _
        Long, Arguments As Long) As Long

' Wandelt eine API-Fehlernummer(GetLastError bzw. Err.LastDllError)
' in einen Fehlertext um.
' Entnommen aus einem ActiveVB-Tipp
Public Function GetErrorString(ByVal ErrorNumber As Long) As String
 Dim Result As Long, Buffer As String
    
    Buffer = Space$(256)
    Result = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, ErrorNumber, _
                           0&, Buffer, Len(Buffer), ByVal 0)
    GetErrorString = Left$(Buffer, Result)
End Function
